IRremoteESP8266: IRDelonghiAc Class Reference

IRremoteESP8266

Public Member Functions | Static Public Member Functions | Private Member Functions | Private Attributes | List of all members
IRDelonghiAc Class Reference

Class for handling detailed Delonghi A/C messages. More...

`#include <ir_Delonghi.h>`

Collaboration diagram for IRDelonghiAc:
[legend]

## Public Member Functions

| IRDelonghiAc (const uint16_t pin, const bool inverted=false, const bool use_modulation=true)
| Class constructor. More...
void | stateReset (void)
| Reset the internal state to a fixed known good state. More...
void | send (const uint16_t repeat=kDelonghiAcDefaultRepeat)
| Send the current internal state as an IR message. More...
int8_t | calibrate (void)
| Run the calibration to calculate uSec timing offsets for this platform. More...
void | begin (void)
| Set up hardware to be able to send a message. More...
void | setPower (const bool on)
| Change the power setting. More...
bool | getPower (void) const
| Get the value of the current power setting. More...
void | on (void)
| Change the power setting to On. More...
void | off (void)
| Change the power setting to Off. More...
void | setTempUnit (const bool celsius)
| Change the temperature scale units. More...
bool | getTempUnit (void) const
| Get the temperature scale unit of measure currently in use. More...
void | setTemp (const uint8_t temp, const bool fahrenheit=false, const bool force=false)
| Set the temperature. More...
uint8_t | getTemp (void) const
| Get the current temperature setting. More...
void | setFan (const uint8_t speed)
| Set the speed of the fan. More...
uint8_t | getFan (void) const
| Get the current native fan speed setting. More...
void | setMode (const uint8_t mode)
| Set the operating mode of the A/C. More...
uint8_t | getMode (void) const
| Get the operating mode setting of the A/C. More...
void | setBoost (const bool on)
| Set the Boost (Turbo) mode of the A/C. More...
bool | getBoost (void) const
| Get the Boost (Turbo) mode of the A/C. More...
void | setSleep (const bool on)
| Set the Sleep mode of the A/C. More...
bool | getSleep (void) const
| Get the Sleep mode status of the A/C. More...
void | setOnTimerEnabled (const bool on)
| Set the enable status of the On Timer. More...
bool | getOnTimerEnabled (void) const
| Get the enable status of the On Timer. More...
void | setOnTimer (const uint16_t nr_of_mins)
| Set the On timer to activate in nr of minutes. More...
uint16_t | getOnTimer (void) const
| Get the On timer time. More...
void | setOffTimerEnabled (const bool on)
| Set the enable status of the Off Timer. More...
bool | getOffTimerEnabled (void) const
| Get the enable status of the Off Timer. More...
void | setOffTimer (const uint16_t nr_of_mins)
| Set the Off timer to activate in nr of minutes. More...
uint16_t | getOffTimer (void) const
| Get the Off timer time. More...
uint64_t | getRaw (void)
| Get a copy of the internal state as a valid code for this protocol. More...
void | setRaw (const uint64_t state)
| Set the internal state from a valid code for this protocol. More...
stdAc::state_t | toCommon (void) const
| Convert the current internal state into its stdAc::state_t equivalent. More...
String | toString (void) const
| Convert the current internal state into a human readable string. More...

## Static Public Member Functions

static uint8_t | calcChecksum (const uint64_t state)
| Calculate the checksum for a given state. More...
static bool | validChecksum (const uint64_t state)
| Verify the checksum is valid for a given state. More...
static uint8_t | convertMode (const stdAc::opmode_t mode)
| Convert a stdAc::opmode_t enum into its native mode. More...
static uint8_t | convertFan (const stdAc::fanspeed_t speed)
| Convert a stdAc::fanspeed_t enum into it's native speed. More...
static stdAc::opmode_t | toCommonMode (const uint8_t mode)
| Convert a native mode into its stdAc equivalent. More...
static stdAc::fanspeed_t | toCommonFanSpeed (const uint8_t speed)
| Convert a native fan speed into its stdAc equivalent. More...

## Private Member Functions

void | checksum (void)
| Calculate and set the checksum values for the internal state. More...

## Private Attributes

IRsend | _irsend
| instance of the IR send class More...
DelonghiProtocol | _
uint8_t | _saved_temp
| The previously user requested temp value. More...
uint8_t | _saved_temp_units
| The previously user requested temp units. More...

## Detailed Description

Class for handling detailed Delonghi A/C messages.

## Constructor & Destructor Documentation

## ◆ IRDelonghiAc()

IRDelonghiAc::IRDelonghiAc | ( | const uint16_t | pin,
|  | const bool | inverted = `false`,
|  | const bool | use_modulation = `true`
| ) |  |

explicit

Class constructor.

Parameters

  [in] | pin | GPIO to be used when sending.
  [in] | inverted | Is the output signal to be inverted?
  [in] | use_modulation | Is frequency modulation to be used?

## Member Function Documentation

## ◆ begin()

void IRDelonghiAc::begin | ( | void |  | ) |

Set up hardware to be able to send a message.

## ◆ calcChecksum()

uint8_t IRDelonghiAc::calcChecksum | ( | const uint64_t | state | ) |

static

Calculate the checksum for a given state.

Parameters

  [in] | state | The value to calc the checksum of.

Returns
  A valid checksum value.

## ◆ calibrate()

int8_t IRDelonghiAc::calibrate | ( | void |  | ) |

inline

Run the calibration to calculate uSec timing offsets for this platform.

Returns
  The uSec timing offset needed per modulation of the IR Led.

Note
  This will produce a 65ms IR signal pulse at 38kHz. Only ever needs to be run once per object instantiation, if at all.

## ◆ checksum()

void IRDelonghiAc::checksum | ( | void |  | ) |

private

Calculate and set the checksum values for the internal state.

## ◆ convertFan()

uint8_t IRDelonghiAc::convertFan | ( | const stdAc::fanspeed_t | speed | ) |

static

Convert a stdAc::fanspeed_t enum into it's native speed.

Parameters

  [in] | speed | The enum to be converted.

Returns
  The native equivalent of the enum.

## ◆ convertMode()

uint8_t IRDelonghiAc::convertMode | ( | const stdAc::opmode_t | mode | ) |

static

Convert a stdAc::opmode_t enum into its native mode.

Parameters

  [in] | mode | The enum to be converted.

Returns
  The native equivalent of the enum.

## ◆ getBoost()

bool IRDelonghiAc::getBoost | ( | void |  | ) | const

Get the Boost (Turbo) mode of the A/C.

Returns
  true, the setting is on. false, the setting is off.

## ◆ getFan()

uint8_t IRDelonghiAc::getFan | ( | void |  | ) | const

Get the current native fan speed setting.

Returns
  The current fan speed.

## ◆ getMode()

uint8_t IRDelonghiAc::getMode | ( | void |  | ) | const

Get the operating mode setting of the A/C.

Returns
  The current operating mode setting.

## ◆ getOffTimer()

uint16_t IRDelonghiAc::getOffTimer | ( | void |  | ) | const

Get the Off timer time.

Returns
  Total nr of mins before the device turns off.

## ◆ getOffTimerEnabled()

bool IRDelonghiAc::getOffTimerEnabled | ( | void |  | ) | const

Get the enable status of the Off Timer.

Returns
  true, the setting is on. false, the setting is off.

## ◆ getOnTimer()

uint16_t IRDelonghiAc::getOnTimer | ( | void |  | ) | const

Get the On timer time.

Returns
  Total nr of mins before the device turns on.

## ◆ getOnTimerEnabled()

bool IRDelonghiAc::getOnTimerEnabled | ( | void |  | ) | const

Get the enable status of the On Timer.

Returns
  true, the setting is on. false, the setting is off.

## ◆ getPower()

bool IRDelonghiAc::getPower | ( | void |  | ) | const

Get the value of the current power setting.

Returns
  true, the setting is on. false, the setting is off.

## ◆ getRaw()

uint64_t IRDelonghiAc::getRaw | ( | void |  | ) |

Get a copy of the internal state as a valid code for this protocol.

Returns
  A valid code for this protocol based on the current internal state.

## ◆ getSleep()

bool IRDelonghiAc::getSleep | ( | void |  | ) | const

Get the Sleep mode status of the A/C.

Returns
  true, the setting is on. false, the setting is off.

## ◆ getTemp()

uint8_t IRDelonghiAc::getTemp | ( | void |  | ) | const

Get the current temperature setting.

Returns
  The current setting for temp. in currently configured units/scale.

## ◆ getTempUnit()

bool IRDelonghiAc::getTempUnit | ( | void |  | ) | const

Get the temperature scale unit of measure currently in use.

Returns
  true, is Fahrenheit. false, is Celsius.

## ◆ off()

void IRDelonghiAc::off | ( | void |  | ) |

Change the power setting to Off.

## ◆ on()

void IRDelonghiAc::on | ( | void |  | ) |

Change the power setting to On.

## ◆ send()

void IRDelonghiAc::send | ( | const uint16_t | repeat = `kDelonghiAcDefaultRepeat` | ) |

Send the current internal state as an IR message.

Parameters

  [in] | repeat | Nr. of times the message will be repeated.

## ◆ setBoost()

void IRDelonghiAc::setBoost | ( | const bool | on | ) |

Set the Boost (Turbo) mode of the A/C.

Parameters

  [in] | on | true, the setting is on. false, the setting is off.

## ◆ setFan()

void IRDelonghiAc::setFan | ( | const uint8_t | speed | ) |

Set the speed of the fan.

Parameters

  [in] | speed | The desired native setting.

## ◆ setMode()

void IRDelonghiAc::setMode | ( | const uint8_t | mode | ) |

Set the operating mode of the A/C.

Parameters

  [in] | mode | The desired native operating mode.

## ◆ setOffTimer()

void IRDelonghiAc::setOffTimer | ( | const uint16_t | nr_of_mins | ) |

Set the Off timer to activate in nr of minutes.

Parameters

  [in] | nr_of_mins | Total nr of mins to wait before turning off the device

Note
  Max 23 hrs and 59 minutes. i.e. 1439 mins.

## ◆ setOffTimerEnabled()

void IRDelonghiAc::setOffTimerEnabled | ( | const bool | on | ) |

Set the enable status of the Off Timer.

Parameters

  [in] | on | true, the setting is on. false, the setting is off.

## ◆ setOnTimer()

void IRDelonghiAc::setOnTimer | ( | const uint16_t | nr_of_mins | ) |

Set the On timer to activate in nr of minutes.

Parameters

  [in] | nr_of_mins | Total nr of mins to wait before waking the device.

Note
  Max 23 hrs and 59 minutes. i.e. 1439 mins.

## ◆ setOnTimerEnabled()

void IRDelonghiAc::setOnTimerEnabled | ( | const bool | on | ) |

Set the enable status of the On Timer.

Parameters

  [in] | on | true, the setting is on. false, the setting is off.

## ◆ setPower()

void IRDelonghiAc::setPower | ( | const bool | on | ) |

Change the power setting.

Parameters

  [in] | on | true, the setting is on. false, the setting is off.

## ◆ setRaw()

void IRDelonghiAc::setRaw | ( | const uint64_t | state | ) |

Set the internal state from a valid code for this protocol.

Parameters

  [in] | state | A valid code for this protocol.

## ◆ setSleep()

void IRDelonghiAc::setSleep | ( | const bool | on | ) |

Set the Sleep mode of the A/C.

Parameters

  [in] | on | true, the setting is on. false, the setting is off.

## ◆ setTemp()

void IRDelonghiAc::setTemp | ( | const uint8_t | degrees,
|  | const bool | fahrenheit = `false`,
|  | const bool | force = `false`
| ) |  |

Set the temperature.

Parameters

  [in] | degrees | The temperature in degrees.
  [in] | fahrenheit | Use Fahrenheit as the temperature scale.
  [in] | force | Do we ignore any sanity checks?

## ◆ setTempUnit()

void IRDelonghiAc::setTempUnit | ( | const bool | fahrenheit | ) |

Change the temperature scale units.

Parameters

  [in] | fahrenheit | true, use Fahrenheit. false, use Celsius.

## ◆ stateReset()

void IRDelonghiAc::stateReset | ( | void |  | ) |

Reset the internal state to a fixed known good state.

## ◆ toCommon()

stdAc::state_t IRDelonghiAc::toCommon | ( | void |  | ) | const

Convert the current internal state into its stdAc::state_t equivalent.

Returns
  The stdAc equivalent of the native settings.

## ◆ toCommonFanSpeed()

stdAc::fanspeed_t IRDelonghiAc::toCommonFanSpeed | ( | const uint8_t | speed | ) |

static

Convert a native fan speed into its stdAc equivalent.

Parameters

  [in] | speed | The native setting to be converted.

Returns
  The stdAc equivalent of the native setting.

## ◆ toCommonMode()

stdAc::opmode_t IRDelonghiAc::toCommonMode | ( | const uint8_t | mode | ) |

static

Convert a native mode into its stdAc equivalent.

Parameters

  [in] | mode | The native setting to be converted.

Returns
  The stdAc equivalent of the native setting.

## ◆ toString()

String IRDelonghiAc::toString | ( | void |  | ) | const

Convert the current internal state into a human readable string.

Returns
  A human readable string.

## ◆ validChecksum()

bool IRDelonghiAc::validChecksum | ( | const uint64_t | state | ) |

static

Verify the checksum is valid for a given state.

Parameters

  [in] | state | The state to verify the checksum of.

Returns
  true, if the state has a valid checksum. Otherwise, false.

## Member Data Documentation

## ◆ _

DelonghiProtocol IRDelonghiAc::_

private

## ◆ _irsend

IRsend IRDelonghiAc::_irsend

private

instance of the IR send class

## ◆ _saved_temp

uint8_t IRDelonghiAc::_saved_temp

private

The previously user requested temp value.

## ◆ _saved_temp_units

uint8_t IRDelonghiAc::_saved_temp_units

private

The previously user requested temp units.

The documentation for this class was generated from the following files:

- src/ir_Delonghi.h
- src/ir_Delonghi.cpp